/*
 * Created by SharpDevelop.
 * User: grunwald
 * Date: 24.07.2006
 * Time: 15:17
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using PPJ.Runtime.Scripting;

namespace ScaeParser
{
	internal enum TokenKind
	{
		Eof,
		Newline,
		Literal,
		Identifier,
		And,
		Or,
		Not,
		OpenParenthesis,
		CloseParenthesis,
		OpenBracket,
		CloseBracket,
		Dot,
		Comma,
		Plus,
		Minus,
		Multiplication,
		Division,
		StringConcat,
		Equals,
		Inequals,
		LessThan,
		GreaterThan,
		LessThanOrEqual,
		GreaterThanOrEqual,
		BitAnd,
		BitOr
	}
	
	internal sealed class Token
	{
		readonly TokenKind kind;
		readonly Literal literalValue;
		readonly string identifierName;
		
		public Token(TokenKind kind)
		{
			this.kind = kind;
		}
		
		public Token(string identifierName)
		{
			this.kind = TokenKind.Identifier;
			this.identifierName = identifierName;
		}
		
		internal Token(Literal literalValue)
		{
			this.kind = TokenKind.Literal;
			this.literalValue = literalValue;
		}
		
		public TokenKind Kind {
			get {
				return kind;
			}
		}
		
		internal Literal LiteralValue {
			get {
				return literalValue;
			}
		}
		
		public string IdentifierName {
			get {
				return identifierName;
			}
		}
	}
}
